__gnu_pbds::detail::pat_trie_base::_Iter< Node, Leaf, Head, Inode, Is_Forward_Iterator >(3cxx)

NAME
__gnu_pbds::detail::pat_trie_base::_Iter< Node, Leaf, Head, Inode, Is_Forward_Iterator >

SYNOPSIS

Inherits __gnu_pbds::detail::pat_trie_base::_CIter< Node, Leaf, Head, Inode, Is_Forward_Iterator >.

  Public Types

typedef _Alloc::template rebind< Head > __rebind_h
typedef _Alloc::template rebind< Inode > __rebind_in
typedef _Alloc::template rebind< Leaf > __rebind_l
typedef _Alloc::template rebind< Node > __rebind_n
typedef allocator_type _Alloc
typedef base_type::allocator_type allocator_type
typedef _CIter< Node, Leaf, Head, Inode, Is_Forward_Iterator > base_type
typedef type_traits::const_pointer const_pointer
typedef type_traits::const_reference const_reference
typedef allocator_type::difference_type difference_type
typedef base_type::head_pointer head_pointer
typedef Inode::iterator inode_iterator
typedef base_type::inode_pointer inode_pointer
typedef std::bidirectional_iterator_tag iterator_category
typedef base_type::leaf_const_pointer leaf_const_pointer
typedef base_type::leaf_pointer leaf_pointer
typedef base_type::node_pointer node_pointer
typedef type_traits::pointer pointer
typedef type_traits::reference reference
typedef base_type::type_traits type_traits
typedef type_traits::value_type value_type

  Public Member Functions

_Iter (node_pointer p_nd=0)
_Iter (const _Iter< Node, Leaf, Head, Inode, !Is_Forward_Iterator > &other)
bool operator!= (const _CIter &other) const
bool operator!= (const _CIter< Node, Leaf, Head, Inode, !Is_Forward_Iterator > &other) const
reference operator* () const
_Iter & operator++ ()
_Iter operator++ (int)
_Iter & operator-- ()
_Iter operator-- (int)
pointer operator-> () const
_Iter & operator= (const _Iter &other)
_Iter & operator= (const _Iter< Node, Leaf, Head, Inode, !Is_Forward_Iterator > &other)
bool operator== (const _CIter &other) const
bool operator== (const _CIter< Node, Leaf, Head, Inode, !Is_Forward_Iterator > &other) const

  Public Attributes

node_pointer m_p_nd

  Protected Member Functions

void dec (false_type)
void dec (true_type)
void inc (false_type)
void inc (true_type)

  Static Protected Member Functions

static node_pointer get_larger_sibling (node_pointer p_nd)
static node_pointer get_smaller_sibling (node_pointer p_nd)
static leaf_pointer leftmost_descendant (node_pointer p_nd)
static leaf_pointer rightmost_descendant (node_pointer p_nd)

Detailed Description

  template<typename Node, typename Leaf, typename Head, typename Inode, bool Is_Forward_Iterator>
class __gnu_pbds::detail::pat_trie_base::_Iter< Node, Leaf, Head, Inode, Is_Forward_Iterator >" Iterator.

Definition at line 713 of file pat_trie_base.hpp.

Author

Generated automatically by Doxygen for libstdc++ from the source code.